<?php

class DB {
	var $myQuery;
	var $dbType;
	var $oConn;
	var $dbName;
		function DB($dbType='') {
		    $dbType = ($dbType) ? $dbType : 'mysql';
		    $dbType = strtolower($dbType);
		    $this->dbType = $dbType;
		}
		function Connect($dbServer,$dbUser,$dbPasswd,$dbName='') {
		    $this->dbName = $dbName;
		    if ($this->dbType == 'mssql') {
			$this->oConn = @mssql_connect($dbServer,$dbUser,$dbPasswd);
			$selectTest = $this->Select($this->dbName, $this->oConn);
			return $this->oConn;
		    } elseif ($this->dbType == 'mysql') {
			$this->oConn = @mysql_connect($dbServer,$dbUser,$dbPasswd);
			$selectTest = $this->Select($this->dbName, $this->oConn);
			return $this->oConn;
		    } elseif ($this->dbType == 'pgsql') {
			$this->oConn = @pg_connect("host=".$dbServer." dbname=".$this->dbName." port=5432 user=postgres");
			return $this->oConn;
		    }
		}
		function pConnect($dbServer,$dbUser,$dbPasswd, $dbName='') {
		    $this->dbName = $dbName;
		    if ($this->dbType == 'mssql') {
			$this->oConn = @mssql_pconnect($dbServer,$dbUser,$dbPasswd);
			$selectTest = $this->Select($this->dbName, $this->oConn);
			return $this->oConn;
		    } elseif ($this->dbType == 'mysql') {
			$this->oConn = @mysql_pconnect($dbServer,$dbUser,$dbPasswd);
			$selectTest = $this->Select($this->dbName, $this->oConn);
			return $this->oConn;
		    } elseif ($this->dbType == 'pgsql') {
			$this->oConn = @pg_pconnect("host=".$dbServer." dbname=".$this->dbName." port=5432 user=postgres");
			return $this->oConn;
		    }
		}
		function Select($dbName, $oConn='') {
		    if (!$oConn) { $oConn = $this->oConn; }
		    if ($this->dbType == 'mssql') {
		    	return @mssql_select_db($dbName, $oConn);
		    } elseif ($this->dbType == 'mysql') {
			return @mysql_select_db($dbName, $oConn);
		    } elseif ($this->dbType == 'pgsql') {
			return true;
		    }
		}
		function CreateRS($Query) {
		    if ($this->dbType == 'mssql') {
			$this->myQuery = mssql_query($Query, $this->oConn);
			return @mssql_fetch_array($this->myQuery);
		    } elseif ($this->dbType == 'mysql') {
		    	$this->myQuery = mysql_query($Query, $this->oConn);
			return @mysql_fetch_object($this->myQuery);
		    } elseif ($this->dbType == 'pgsql') {
			$this->myQuery = pgsql_query($this->oConn, $Query);
			return @pg_fetch_object($this->myQuery);
		    }
		}
		function Query($dbSelect) {
		    $GLOBALS[QueryCount]++;
		    if ($this->dbType == 'mssql') {
		        return @mssql_query($dbSelect, $this->oConn);
		    } elseif ($this->dbType == 'mysql') {
		        return @mysql_query($dbSelect, $this->oConn);
		    } elseif ($this->dbType == 'pgsql') {
		        return @pg_exec($this->oConn, $dbSelect);
		    }
		}
		function FetchArray($dbObject, $arrType='') {
		    $arrType = (strlen($arrType) > 0) ? $arrType : MYSQL_BOTH;
		    if ($this->dbType == 'mssql') {
		        return @mssql_fetch_array($dbObject);
		    } elseif ($this->dbType == 'mysql') {
		        return @mysql_fetch_array($dbObject,$arrType);
		    } elseif ($this->dbType == 'pgsql') {
		        return @pg_fetch_array($this->oConn, $dbObject);
		    }
		}
		function FetchObject($dbObject) {
		    if ($this->dbType == 'mssql') {
		        return @mssql_fetch_object($dbObject);
		    } elseif ($this->dbType == 'mysql') {
		        return @mysql_fetch_object($dbObject);
		    } elseif ($this->dbType == 'pgsql') {
		        return @pg_fetch_object($dbObject);
		    }
		}
		function FetchRow($dbObject) {
		    if ($this->dbType == 'mssql') {
		        return @mssql_fetch_row($dbObject);
		    } elseif ($this->dbType == 'mysql') {
		        return @mysql_fetch_row($dbObject);
		    } elseif ($this->dbType == 'pgsql') {
		        return @pg_fetch_row($this->oConn, $dbObject);
		    }
		}
		function AffectedRows($cLink="") {
		    $cLink = (!$cLink) ? $this->oConn : $cLink;
		    if ($this->dbType == 'mssql') {
		        return @mssql_affected_rows($cLink);
		    } elseif ($this->dbType == 'mysql') {
		        return @mysql_affected_rows($cLink);
		    } elseif ($this->dbType == 'pgsql') {
		        return @pg_cmdtuples($cLink);
		    }
		}
		function Close($cLink) {
		    if ($this->dbType == 'mssql') {
		    	return @mssql_close($cLink);
		    } elseif ($this->dbType == 'mysql') {
		    	return @mysql_close($cLink);
		    } elseif ($this->dbType == 'pgsql') {
		    	return @pg_close($cLink);
		    }
		}
		function DataSeek($dbObject, $nNum) {
		    if ($this->dbType == 'mssql') {
		        return @mssql_data_seek($dbObject, $nNum);
		    } elseif ($this->dbType == 'mysql') {
		        return @mysql_data_seek($dbObject, $nNum);
		    } elseif ($this->dbType == 'pgsql') {
		        return @pg_fetch_object($dbObject, $nNum);
		    }
		}
		function FetchField($cField) {
		    if ($this->dbType == 'mssql') {
		        return @mssql_fetch_field($cField);
		    } elseif ($this->dbType == 'mysql') {
		        return @mysql_fetch_field($cField);
		    }
		}
		function FieldSeek($dbObject, $cField) {
		    if ($this->dbType == 'mssql') {
		        return @mssql_field_seek($dbObject, $cField);
		    } elseif ($this->dbType == 'mysql') {
		        return @mysql_field_seek($dbObject, $cField);
		    }
		}
		function FreeResult($cResult="") {
		    if ($this->dbType == 'mssql') {
			return @mssql_free_result($cResult);
		   } elseif ($this->dbType == 'mysql') {
			return @mysql_free_result($cResult);
		    } elseif ($this->dbType == 'pgsql') {
			return @pg_freeresult($cResult);
		    }
		}
		function NumFields($cResult="") {
		    if ($this->dbType == 'mssql') {
		        return @mssql_num_fields($cResult);
		    } elseif ($this->dbType == 'mysql') {
		        return @mysql_num_fields($cResults);
		    }
		}
		function NumRows($cResult="") {
		    if ($this->dbType == 'mssql') {
			return @mssql_num_rows($cResult);
		    } elseif ($this->dbType == 'mysql') {
			return @mysql_num_rows($cResult);
		    } elseif ($this->dbType == 'pgsql') {
			return @pg_numrows($cResult);
		    }
		}
		function Result($cResult, $cOffset, $cField='') {
		    if ($this->dbType == 'mssql') {
			return @mssql_result($cResult, $cOffset, $cField);
		    } elseif ($this->dbType == 'mysql') {
			return @mysql_result($cResult, $cOffset, $cField);
		    } elseif ($this->dbType == 'pgsql') {
		        return @pg_result($cResult, $cOffset, $cField);
		    }
		}
		function Error($cLink="") {
		    $cLink = (!$cLink) ? $this->oConn : $cLink;
		    if ($this->dbType == 'mssql') {
			return @mssql_error($cLink);
		    } elseif ($this->dbType == 'mysql') {
			return @mysql_error($cLink);
		    } elseif ($this->dbType == 'pgsql') {
		        return @pg_error($cLink);
		    }
		}
		function Errno($cLink="") {
		    $cLink = (!$cLink) ? $this->oConn : $cLink;
		    if ($this->dbType == 'mssql') {
			return @mssql_errno($cLink);
		    } elseif ($this->dbType == 'mysql') {
			return @mysql_errno($cLink);
		    } elseif ($this->dbType == 'pgsql') {
		        return @pg_errno($cLink);
		    }
		}
		function GetID($LinkID='') {
		    $LinkID = (!$LinkID) ? $this->oConn : $LinkID;
		    if ($this->dbType == 'mysql') {
		    	return @mysql_insert_id();
		    } elseif ($this->dbType == 'pgsql') {
			return @pg_getlastoid();
		    }
		}
}
?>
