<?php

function PopulateContent($text) {
	global $Detail;
	$text = preg_replace("/<%(.*?)%>/eim", "\$Detail['\\1']" , $text, -1);
	$text = preg_replace("/\r\n/", "<br>" , $text, -1);
	return $text;
}


function print_var($variable, $name='') {
    global $Session, $doDebug, $DB;
    // Clear previous debug entries
    if($DoDebug == false) {
	    $sql = "delete from debug where sid = '".session_id()."' or timestamp < '".(mktime() - 300)."'";
	    $DB->Query($sql);
    }

    $doDebug = true;
    if(is_array($variable)) {
	    $sql = "insert into debug (sid, name, data, timestamp) values ('".session_id()."', '".SaveData($name)."', '".Serialize($variable)."', '". mktime()."')";
	    $DB->Query($sql);
    } else {
	    $sql = "insert into debug (sid, name, data, timestamp) values ('".session_id()."', '".SaveData($name)."', '".Serialize($variable)."', '". mktime()."')";
	    $DB->Query($sql);
    }
    return;
}


function ShowImg($name, $alt='', $align='') {
    global $image_root;
    $imgStr = '<image src="'.$image_root.$name.'" border="0" alt="'.$alt.'" align="'.$align.'">';
    return $imgStr;
}
function ShowData($scStr) {
global $Session, $sectionid;
	$scStr = str_replace('!~~!',"'",$scStr);
	$scStr = str_replace("&nbsp;&nbsp;", "  ", $scStr);
	$scStr = str_replace("<br/>", "\r\n", $scStr);
	$scStr = str_replace("&", "&amp;", $scStr);
	$scStr = stripSlashes($scStr);
	$scStr = trim($scStr);
	return $scStr;
}

function DisplayData($scStr) {
global $Session, $sectionid;
	$scStr = str_replace('!~~!',"'",$scStr);
	$scStr = str_replace("&nbsp;&nbsp;", "  ", $scStr);
	$scStr = stripSlashes($scStr);
	$scStr = trim($scStr);
	return $scStr;
}

function SaveData($scStr, $noflag='', $nofilter='') {
	$scStr = trim($scStr);
	$scStr = CheckHTML($scStr);
	$scStr = str_replace("'","!~~!", $scStr);
	$scStr = str_replace("\r\n","<br/>", $scStr);
	return $scStr;
}

function SaveRS($cTable, $cQuery, $db=''){
	global $HTTP_POST_VARS, $DB, $Session, $dosave, $dodone;
	$DB = ($db) ? $db : $DB;
    //echo $cQuery;
	if (!$cQuery) {
		die('SaveRS Must Have A Where Clause!');
	} else {
		if ($dosave || $dodone) {
			reset($HTTP_POST_VARS);
			$strValue = " ";
			$count    = 0;
			while(list($key,$value) = each($HTTP_POST_VARS)) {
				if (ParseRecord($key)) {
			    	$count++;
				$SaveName = ParseRecord($key);
				$value         = SaveData($value);
				$strValue .= ($count == 1)  ? "`" . $SaveName . "` = '".$value."'" : ", `".$SaveName."` = '".$value."'";
				}
				# Let's Handle Checkboxes now!!
				if (substr($key,0,4) == 'chk_') {
					$saveName         = substr($key, 4);
					$theRecordSet = ParseRecord($saveName);
					$otherCheck     = 'rs'.$key;
					$strValue .= ($HTTP_POST_VARS[$otherCheck]) ? ", `" . $theRecordSet . "` = 1" : ", `" . $theRecordSet . "` = 0";

				}
				//Let's Handle Date Records
				if (ParseDateRecord($key)) {
					$count++;
					$SaveName = ParseDateRecord($key);
					$value = ($value) ? SaveData(ConvertDate($value)) : '';
					$strValue .= ($count == 1)  ? "`" . $SaveName . "` = '".$value."'" : ", `".$SaveName."` = '".$value."'";
				}
			}
			if (substr($strValue, 0, 2) == ' ,') {
				$strValue = substr($strValue, 2);
			}
			$cUpdate = "update ". $cTable . " set " . $strValue . " " . $cQuery;
			$cWhere  = SaveData('Set ' . $strValue . " " . $cQuery, 1);
			//echo $cUpdate;
			$DB->Query($cUpdate);
			reset($HTTP_POST_VARS);
		}
	}
}

function AddRS($cTable, $db=''){
	global $donew, $HTTP_POST_VARS, $DB;
	$DB = ($db) ? $db : $DB;
	if ($donew) {
		reset($HTTP_POST_VARS);
		$strKey = " (";
		$strValue = " VALUES (";
		$count = 0;
		while(list($key,$value) = each($HTTP_POST_VARS)) {
			if (ParseRecord($key)) {
				$count++;
				$SaveName = ParseRecord($key);
				if ($count == 1) {
					$strKey .= ' `' . $SaveName . '` ';
					$strValue .= "'".SaveData($value)."'";
				} else {
					$strKey .= ', `' . $SaveName . '` ';
					$strValue .= ", '" . SaveData($value)."' ";
				}
			}
			if (ParseDateRecord($key)) {
				$count++;
				$SaveName = ParseDateRecord($key);
				$value = ($value) ? SaveData(ConvertDate($value)) : '';
				if ($count == 1) {
					$strKey .= ' `' . $SaveName . '` ';
					$strValue .= "'".SaveData($value)."'";
				} else {
					$strKey .= ', `' . $SaveName . '` ';
					$strValue .= ", '" . SaveData($value)."' ";
				}
			}
		}
		$cInsert = "INSERT INTO " . $cTable . " " . $strKey . ")" . $strValue . ")";
		$cWhere  = SaveData('(' . $strKey . ')' . $strValue . ')', 1);
		$_tmp = $DB->Query($cInsert);
       		 //echo $cInsert;
		reset($HTTP_POST_VARS);
		return $DB->GetID($_tmp);
	}
}


function DelRS($cTable, $cQuery, $flag='', $db='') {
    global $dodelete, $DB;
    $DB = ($db) ? $db : $DB;
    if (!$cQuery) {
        die('SaveRS Must Have A Where Clause!');
    } else {
        if ($dodelete) {
            if ($flag) {
                $cDelete = 'UPDATE ' . $cTable . ' SET deleted=1 ' . $cQuery;
            } else {
                $cDelete = 'DELETE FROM ' . $cTable . ' ' . $cQuery;
            }
            $DB->Query($cDelete);
        }
    }
}

function ConvertDate($date, $switch='') {
	if ($date) {
		if (!$switch) {
			$dateArray = explode("/", $date);
			$strReturn = mktime(0,0,0,$dateArray[0],$dateArray[1],$dateArray[2]);
		} else {
			$strReturn = date("m/d/Y", $date);
		}
	} else {
		$strReturn = '';
	}
	return $strReturn;
}

function ParseDateRecord($RecordName) {
	if (substr($RecordName,0,12) == "date_record_") {
		return trim(strtolower(substr($RecordName,12)));
	}
}

function ParseRecord($RecordName) {
	if (substr($RecordName,0,7) == "record_") {
		return trim(strtolower(substr($RecordName,7)));
	}
}

function DoDebug($loStrData) {
    if ($GLOBALS[cDebugIP] == GetIP()) {
        echo '<font size="-1"><b>' . $loStrData . '</b></font><br>';
    }
}

function ThisURL() {
    return getenv("SCRIPT_NAME");
}

function BaseURL() {
    global $baseURL;
    return $baseURL; 
}

function ThisFile() {
    $strData  = getenv("SCRIPT_NAME");
    $chopSpot = strrpos($strData,"/");
    $strData  = substr ($strData, $chopSpot + 1);
    return $strData;
}

function GetIP() {
    return getenv("REMOTE_ADDR");
}

function GetIPName() {
    return gethostbyaddr(getenv("REMOTE_ADDR"));
}


function ReDirect($cURL) {
    header('Location: ' . $cURL.((strchr($cURL, '?')) ? '&amp;' : '?').SID);
    exit;
}

function Now() {
	$strData = date("F j, Y - g:i:s A", mktime());
	return $strData;
}


function Spacer() {
    return '<img src="/images/spacer.gif" alt="">';
}

function TheDate() {
    return date("n/d/Y");
}

function TheTime() {
	$strData = date("g:i A", mktime());
    return $strData;
}

function Translate($str) {
    //Empty Translate function//
    //For later use//
    return $str;
}

function CheckHTML($str, $strip='', $noValidate='') {
	# 2 means accept all qualifiers: <foo bar>
	# 1 means accept the tag only: <foo>
	if ($strip != 'nohtml') {
		$AllowableHTML = array(
			'p' => 2,
			'b' => 1,
			'i' => 1,
			'u' => 1,
			'a' => 2,
			'img' => 2,
			'em' => 1,
			'br' => 1,
			'strong' => 1,
			'blockquote' => 1,
			'center' => 1,
			'li' => 1,
			'ol' => 2,
			'div' => 2,
			'ul' => 2,
			'font' => 2,
			'table' => 2,
			'tr' => 2,
			'td' => 2,
			'th' => 2,
			'hr' => 2,
			'map' => 2,
			'area' => 2,
			'html' => 2,
			'body' => 2,
			'h1' => 2,
			'h2' => 2,
			'h3' => 2,
			'h4' => 2,
			'h5' => 2,
			'%' => 1,
			'h6' => 2
		);
	} else {
		$AllowableHTML = array();
	}
	$str = stripslashes($str);
	//$str = str_replace('><', ">\n<", $str);
	$str = str_replace('IC "-//W3C//DTD HTML 4.0 Transitional//EN"', '', $str);
	$str = eregi_replace("<[[:space:]]*([^>]*)[[:space:]]*>","<\\1>",$str);
	$tmp = '';
	while (eregi("<([^> ]*)([^>]*)>",$str,$reg)) {
		$i = strpos($str,$reg[0]);
		$l = strlen($reg[0]);
		if ($reg[1][0] == '/') {
			$tag = trim(strtolower(substr($reg[1],1)));
		} elseif ($reg[1][0] == '%') {
		    $tag = '<'.$tag.'>';
            break;
		} else {
			$tag = trim(strtolower($reg[1]));
		}
		if (($AllowableHTML[$tag] == 1) || ($AllowableHTML[$tag] == 2)) {
			if ($reg[1][0] == '/') {
				$tag = '</'.$tag.'>';
			} elseif ($a == 1) {
				$tag = '<'.$tag.'>';
			} else {
				if (trim($reg[2])) {
					$tag = '<'.$tag. ' '.trim($reg[2]). '>';
				} else {
					$tag = '<'.$tag. '>';
				}
				$counter = substr_count($tag, '"');
				if ($counter % 2) {
					$tag = str_replace('"', '', $tag);
				}
			}
		} else {
			$tag = "";
		}
		$tmp .= substr($str, 0, $i).$tag;
		$str = substr($str, $i+$l);
	}
	$str = $tmp . $str;
	// Squash PHP tags unconditionally
	$str = ereg_replace("<\?",'',$str);
	$str = ereg_replace("\?>",'',$str);
	//$str = ereg_replace("<%",'',$str);
	//$str = ereg_replace("%>",'',$str);
	#if (!$noValidate) {
	#	$str = ValidateHTML($str, true);
	#	$str = CheckHTML($str, '', true);
	#}
        return $str;
}
function PullBrowser($thisStr) {
    if ((ereg("Nav", $thisStr)) || (ereg("Gold", $thisStr)) || (ereg("X11", $thisStr)) || (ereg("Mozilla", $thisStr)) || (ereg("Netscape", $thisStr)) AND (!ereg("MSIE", $thisStr))) {
        $browser = "NS";
    } elseif(ereg("MSIE", $thisStr)) {
        $browser = "IE";
    } elseif(ereg("Lynx", $thisStr)) {
        $browser = "Lynx";
    } elseif(ereg("Opera", $thisStr)) {
        $browser = "Opera";
    } elseif(ereg("WebTV", $thisStr)) {
        $browser = "WebTV";
    } elseif(ereg("Konqueror", $thisStr)) {
        $browser = "Konqueror";
    } elseif((eregi("bot", $thisStr)) || (ereg("Google", $thisStr)) || (ereg("Slurp", $thisStr)) || (ereg("Scooter", $thisStr)) || (eregi("Spider", $thisStr)) || (eregi("Infoseek", $thisStr))) {
        $browser = "Bot";
    } else {
        $browser = "Other";
    }
    return $browser;
}

function PullBrowserVersion($thisStr,$thisType) {
	switch ($thisType) {
		case 'NS' :
			$version = substr(substr($thisStr, (strpos($thisStr, 'Netscape') + 8)),0,1);
			if ($version == 5) {
			    //Fix for Mozilla 1.0 + Make it look like Netscape 6
			    $version = 6;
			}
			break;
		case 'IE' :
			$version = substr(substr($thisStr, (strpos($thisStr, 'MSIE') + 4)),1,1);
			break;
		case 'Lynx' :
			$version = '';
			break;
		case 'Opera' :
			$version = '';
			break;
		case 'WebTV' :
			$version = '';
			break;
		case 'Konqueror' :
			$version = '';
			break;
		case 'Bot' :
			$version = '';
			break;
		case 'Other' :
			$version = '';
			break;
	}
    return $version;
}

function PullOS($thisStr) {
    if (ereg("Win", $thisStr)) {
        $os = "WIN";
    } elseif((ereg("Mac", $thisStr)) || (ereg("PPC", $thisStr))) {
        $os = "Macintosh";
    } elseif(ereg("Linux", $thisStr)) {
        $os = "Linux";
    } elseif(ereg("FreeBSD", $thisStr)) {
        $os = "FreeBSD";
    } elseif(ereg("SunOS", $thisStr)) {
        $os = "SunOS";
    } elseif(ereg("IRIX", $thisStr)) {
        $os = "IRIX";
    } elseif(ereg("BeOS", $thisStr)) {
        $os = "BeOS";
    } elseif(ereg("OS/2", $thisStr)) {
        $os = "OS2";
    } elseif(ereg("AIX", $thisStr)) {
        $os = "AIX";
    } else {
        $os = "Other";
    }
    return $os;
}

function DotString($inStr, $strLen='', $noDot='') {
	$strLen = $strLen ? $strLen : 155;
	if (strlen($inStr) > $strLen) {
		$newStr = substr($inStr, 0, $strLen);
		if (!$noDot) { $newStr = $newStr.'...';}
	} else {
		$newStr = $inStr;
	}
	return $newStr;
}
function JS_Close($cURL='', $cExtras='') {
	$br = "\n";
	$strData = '<html>'.$br;
	$strData = '<head>'.$br;
	$strData .= '<script language="JavaScript">'.$br;
	$strData .= '<!--//'.$br;
	if ($cExtras) {
	    $strData .= $cExtras.$br;
	}
	if ($cURL) {
		$strData .= "    opener.location='".$cURL."'; parent.window.close(); opener.focus();".$br;
	} else {
		$strData .= '    opener.reload; opener.focus();'.$br;
		$strData .= '    parent.window.close();'.$br;
	}
	$strData .= '//-->'.$br;
	$strData .= '</script>'.$br;
	$strData .= '</head>'.$br;
	$strData .= '</html>'.$br;
	echo($strData);
	exit;
}

function Remove_Dups_From_Array($array){
    $newArray = array();
    while (list($key, $value) = each($array)) {
	$newArray[$value] = $key;
    }
    reset($newArray);
    unset($array);
    $array = array();
    while (list($key, $value) = each($newArray)) {
	$array[$value] = $key;
    }
    return $array;
}

function SendEmail($toaddress, $fromaddress, $fromname, $subject, $message, $priority='') {
	if ($toaddress && $fromaddress && $message) {
		$priority = ($priority) ? $priority : 1;
		$subject = ($subject) ? $subject : '[No Subject Entered]';
		$headers = "From: $fromname <$fromaddress>\n";
		$headers .= "X-Sender: <$fromaddress>\n";
		$headers .= "X-Mailer: Company name Here\n"; // mailer
		$headers .= "X-Priority: $priority\n"; // Urgent message!
		$headers .= "Return-Path: <$fromaddress>\n";
		$headers .= "Reply-To: <$fromaddress>\n";
		$cNow = date("g:i:s a - n/j/Y", mktime());
		$message .= "\n\nDate & Time Sent: ".$cNow." CST\nMail Originated From: ".gethostbyaddr(getenv("REMOTE_ADDR"))." (".getenv("REMOTE_ADDR").")\n" ;
		$message = wordwrap($message);
		mail($toaddress, $subject, $message, $headers, ' -f '.$fromaddress);
	}
}

function GetDirArray ($dirName, $recursive='') 
{ 
	$d = dir($dirName); 
	while($entry = $d->read()) 
	{ 
		if ($entry != "." && $entry != "..") 
		{ 
			if (is_dir($dirName."/".$entry) && $recursive) 
			{ 
				getDirList($dirName."/".$entry); 
			} 
			else 
			{ 
				echo $dirName."/".$entry." \n"; 
			} 
		} 
	} 
	$d->close(); 
} 

?>
<?php
/* $Id: functions.php,v 1.20 2002/09/15 17:44:33 shaggy Exp $ */

/*
Copyright (c) 2001, 2002 by Martin Tsachev. All rights reserved.
mailto:shaggy@members.evolt.org
http://martin.f2o.org

Redistribution and use in source and binary forms,
with or without modification, are permitted provided
that the conditions available at
http://www.opensource.org/licenses/bsd-license.html
are met.
*/

$styles = Array(
	'gray',
	'white',
	'charcoal',
	'blue',
	'clean_gray');

$now = gmdate("'Y-m-d H:i:s'");

function format_datetime($date) {
	$date = strtotime($date);
	return (date($_SESSION['style']['datetime'],
		$date + $_SESSION['GMT_offset']) . ' GMT ' . $_SESSION['GMT_offset_str']);
}


function format_date($date) {
	$date = strtotime($date);
	return date($_SESSION['style']['date'], $date);
}

function uri_self() {
	return $_SERVER['PHP_SELF'];
}

function send_cookie($name, $value) {
	if (!headers_sent()) {
		// expires in one year
		setcookie($name, $value, time() + 31104000, '/');
	}
}


function delete_cookie($name) {
	if (!headers_sent() ) {
		setcookie($name, 'bogus', time() - 3600, '/');
	}
}


$email = 'username@example.com';
$mail_params = "-f$email"; // set sender to email
$mail_headers =
	"Return-path: $email\r\n" .
	"Bcc: $email\r\n";


function mail_them($to, $subject, $message) {
	global $mail_params, $mail_headers, $email;

	$headers = $mail_headers . 'From: "John Doe" <' . "$email>\r\n";

	if (mail($to, $subject, $message, $headers, $mail_params) ) {
		$message = "Mail sent to $to.";
	} else {
		$message = "Mail was <strong>not</strong> sent to $to.";
	}
	return $message;
}

function encodeEmail($email) {
    return $email;
}
?>
